Files
lbmk/lbmk
T
Leah Rowe 12b33eb8c1 lbmk script: always clean up /tmp files
export TMPDIR to scripts, and handle it in a way that
we know lbmk set it

delete it at the end of the parent process, but not child
processes; when the lbmk script calls itself, child processes
will not delete the tmp directory.

some scripts in lbmk weren't cleaning up the tmpfiles they
made, and they still don't, but this mitigates that.

now in follow-up commits, i can start cleaning up those
scripts too.

not handled by this patch:
if the user cancels lbmk (ctrl+c), the tmp directory will
still be there. this too will be handled, in subsequent
patches

Signed-off-by: Leah Rowe <leah@libreboot.org>
2023-09-01 01:36:34 +01:00

170 lines
4.1 KiB
Bash
Executable File

#!/usr/bin/env sh
# generic script for calling other scripts in lbmk
#
# Copyright (C) 2014,2015,2020,2021,2023 Leah Rowe <info@minifree.org>
# Copyright (C) 2015 Patrick "P. J." McDermott <pj@pehjota.net>
# Copyright (C) 2015, 2016 Klemens Nanni <contact@autoboot.org>
# Copyright (C) 2022, Caleb La Grange <thonkpeasant@protonmail.com>
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.
#
[ "x${DEBUG+set}" = 'xset' ] && set -v
set -u -e
. "include/err.sh"
tmpdir=""
tmpdir_was_set="y"
set | grep TMPDIR 1>/dev/null 2>/dev/null || tmpdir_was_set="n"
if [ "${tmpdir_was_set}" = "y" ]; then
tmpdir="${TMPDIR##*/}"
tmpdir="${TMPDIR%_*}"
if [ "${tmpdir}" = "lbmk" ]; then
tmpdir=""
tmpdir_was_set="n"
fi
fi
if [ "${tmpdir_was_set}" = "n" ]; then
export TMPDIR="/tmp"
tmpdir="$(mktemp -d -t lbmk_XXXXXXXX)"
export TMPDIR="${tmpdir}"
else
export TMPDIR="${TMPDIR}"
fi
tmpdir="${TMPDIR}"
projectname="$(cat projectname)"
buildpath=""
mode=""
option=""
main()
{
id -u 1>/dev/null 2>/dev/null || \
fail "cannot ascertain user id"
[ "${0##*/}" = "lbmk" ] && fail "Don't run this script directly."
[ $# -lt 1 ] && fail "Too few arguments. Try: ${0} help"
mode="${1}"
if [ "${mode}" = "dependencies" ]; then
if [ $# -lt 2 ]; then
printf "You must specify a distro, namely:\n" 1>&2
printf "Look at files under resources/dependencies/\n" \
1>&2
printf "Example: ./build dependencies debian\n" 1>&2
fail "target not specified"
fi
install_dependencies $@ || fail "Could not install dependencies"
lbmk_exit 0
fi
if [ "$(id -u)" = "0" ]; then
fail "running this command as root is not permitted"
fi
buildpath="./script/${0##*/}"
[ "${mode}" = "help" ] && usage ${0} && exit 0
[ "${mode}" = "list" ] && ./build command options "${buildpath}" && \
exit 0
[ $# -lt 2 ] && usage ${0} && exit 1
./checkgit || fail "Please read: https://libreboot.org/docs/build/"
option="${2}"
shift 2
./script/misc/versioncheck || \
fail "Cannot check lbmk version"
case "${option}" in
list)
./build command options "${buildpath}/${mode}" ;;
all)
for option in $(./build command options "${buildpath}/${mode}")
do
"${buildpath}/${mode}/${option}" $@ || \
fail "script fail: ${buildpath}/${mode}/${option} $@"
done
;;
*)
if [ ! -d "${buildpath}/${mode}" ]; then
usage $0
fail "Invalid mode '${mode}'. Run: ${0} help"
elif [ ! -f "${buildpath}/${mode}/${option}" ]; then
usage $0
printf "Invalid option for '%s'." ${mode}
fail "Run: ${0} ${mode} list'."
fi
"${buildpath}/${mode}/${option}" $@ || fail "lbmk error"
esac
lbmk_exit 0
}
install_dependencies()
{
[ -f "resources/dependencies/${2}" ] || fail "Unsupported target"
aur_notice=""
. "resources/dependencies/${2}"
${pkg_add} ${pkglist} || \
fail "install_dependencies: Error installing dependencies"
[ "${aur_notice}" = "" ] || \
printf "You must install AUR packages: %s\n" "${aur_notice}" 1>&2
}
usage()
{
progname=${0}
cat <<- EOF
USAGE: ${progname} <MODE> <OPTION>
possible values for 'mode':
$(./build command options "${buildpath}/${mode}")
Example: ${progname} module all
Example: ${progname} module flashrom [static]
Example: ${progname} roms withgrub
Example: ${progname} clean all
Refer to ${projectname} documentation for more info.
EOF
}
lbmk_exit()
{
tmp_cleanup || err "could not remove tmpdir on lbmk exit: ${tmpdir}"
exit $1
}
fail()
{
tmp_cleanup || printf "WARNING: could not remove tmpdir: %s\n" \
"${tmpdir}" 1>&2
err "${1}"
}
tmp_cleanup()
{
if [ "${tmpdir_was_set}" = "n" ]; then
rm -Rf "${tmpdir}" || return 1
fi
}
main $@